/***************************************************************************
 *   Copyright (C) 2006 by Borko Boskovic                                  *
 *   borko.boskovic@uni-mb.si                                              *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/

/**
 * \file square.h
 */

#ifndef SQUARE_H
#define SQUARE_H

#include <glib.h>

#define a1 0 
#define b1 1 
#define c1 2 
#define d1 3
#define e1 4 
#define f1 5 
#define g1 6 
#define h1 7 
#define a2 8 
#define b2 9 
#define c2 10
#define d2 11
#define e2 12 
#define f2 13 
#define g2 14 
#define h2 15 
#define a3 16 
#define b3 17 
#define c3 18 
#define d3 19 
#define e3 20 
#define f3 21 
#define g3 22 
#define h3 23 
#define a4 24
#define b4 25
#define c4 26 
#define d4 27 
#define e4 28 
#define f4 29 
#define g4 30 
#define h4 31 
#define a5 32 
#define b5 33 
#define c5 34
#define d5 35 
#define e5 36 
#define f5 37 
#define g5 38 
#define h5 39 
#define a6 40 
#define b6 41
#define c6 42 
#define d6 43
#define e6 44 
#define f6 45 
#define g6 46
#define h6 47 
#define a7 48 
#define b7 49 
#define c7 50 
#define d7 51
#define e7 52 
#define f7 53 
#define g7 54 
#define h7 55 
#define a8 56 
#define b8 57 
#define c8 58 
#define d8 59 
#define e8 60
#define f8 61 
#define g8 62 
#define h8 63

#define File_A 0
#define File_B 1
#define File_C 2
#define File_D 3
#define File_E 4
#define File_F 5
#define File_G 6
#define File_H 7

#define Rank_1 0
#define Rank_2 1
#define Rank_3 2
#define Rank_4 3
#define Rank_5 4
#define Rank_6 5
#define Rank_7 6
#define Rank_8 7

#define file(s)		((s)&7) 
#define rank(s)		((s)>>3) 
#define opposite(s)		(s^070) 
#define getSquare(f,r)	((r<<3)|f) 

#define F1G1 	((1ull<<f1)|(1ull<<g1)) 
#define B1C1D1 	((1ull<<b1)|(1ull<<c1)|(1ull<<d1))
#define F8G8 	((1ull<<f8)|(1ull<<g8))
#define B8C8D8	((1ull<<b8)|(1ull<<c8)|(1ull<<d8))
#define G2 		(1ull<<g2)
#define G7 		(1ull<<g7)
#define B2 		(1ull<<b2)
#define B7 		(1ull<<b7)
#define H2H3 	((1ull<<h2)|(1ull<<h3))
#define H7H6 	((1ull<<h7)|(1ull<<h6))
#define A2A3 	((1ull<<a2)|(1ull<<a3))
#define A7A6 	((1ull<<a7)|(1ull<<a6))
#define F2G3H2 	((1ull<<f2)|(1ull<<g3)|(1ull<<h2))
#define F7G6H7 	((1ull<<h7)|(1ull<<g6)|(1ull<<h7))
#define A2B3C2 	((1ull<<a2)|(1ull<<b3)|(1ull<<c2))
#define A7B6C7 	((1ull<<a7)|(1ull<<b6)|(1ull<<c7))
#define D4E4D5E5	((1ull<<d4)|(1ull<<e4)|(1ull<<d5)|(1ull<<e5))

#define RANK_1 255ull
#define RANK_2 65280ull
#define RANK_3 16711680ull
#define RANK_4 4278190080ull
#define RANK_5 1095216660480ull
#define RANK_6 280375465082880ull
#define RANK_7 71776119061217280ull
#define RANK_8 18374686479671623680ull

#define FILE_A 72340172838076673ull
#define FILE_B 144680345676153346ull
#define FILE_C 289360691352306692ull
#define FILE_D 578721382704613384ull
#define FILE_E 1157442765409226768ull
#define FILE_F 2314885530818453536ull
#define FILE_G 4629771061636907072ull
#define FILE_H 9259542123273814144ull

#define NOT_FILE_A (~FILE_A)
#define NOT_FILE_B (~FILE_B)
#define NOT_FILE_G (~FILE_G)
#define NOT_FILE_H (~FILE_H)
#define NOT_FILE_AB ((NOT_FILE_A)&(NOT_FILE_B))
#define NOT_FILE_GH ((NOT_FILE_G)&(NOT_FILE_H))

static const guint64 BFILE[8] = {FILE_A, FILE_B, FILE_C, FILE_D, FILE_E, FILE_F, FILE_G, FILE_H};
static const guint64 BRANK[8] = {RANK_1, RANK_2, RANK_3, RANK_4, RANK_5, RANK_6, RANK_7, RANK_8};
static const guint64 GET_RANK_7[2] = {RANK_7, RANK_2};
static const guint Get_Rank_8[2] = {Rank_8,Rank_1};
static const guint Get_Rank_7[2] = {Rank_7,Rank_2};

void squareToString(const guint square, gchar string[3]);
guint stringToSquare(const gchar string[3]);

static inline gint distance(const gint from, const gint to){
	gint dist1 = ABS(file(from) - file(to));
	gint dist2 = ABS(rank(from) - rank(to));
	return MAX(dist1,dist2);
}

static inline guint cornerDistance(const guint square){
	guint f = file(square);
	guint r = rank(square);
	if(f > 4) f = 7 - f;
	if(r > 4) r = 7 - r;
	return MAX(f,r);
}

#endif
